<?php
require_once('./php/_init.php');
require_once('./lib/json/JSON.php');
require_once('./lib/tcpdf/config/lang/jpn.php');
require_once('./lib/tcpdf/tcpdf.php');

$dl1 = isset($_GET['dl']) ? htmlspecialchars($_GET['dl']) : null;
$id = isset($_GET['id']) ? htmlspecialchars($_GET['id']) : "";
$mode = isset($_GET['edit_mode']) ? htmlspecialchars($_GET['edit_mode']) : "";
$syain = isset($_GET['syain']) ? htmlspecialchars($_GET['syain']) : "1";
$preview = isset($_GET['preview']) ? htmlspecialchars($_GET['preview']) : "";

if($id == "" && $preview == ""){
	exit();
}

if($mode == ""){
	exit();
}

//ログインしていない場合 exit
if($current_uid == 0){
	exit();
}

$con = con();
$sql = "select txt FROM `doc` WHERE id = '" . $id . "'";

if($preview != ""){
	$sql = "select txt FROM `doc_preview` WHERE uid = '" . $current_uid . "'";
}

$ret = exe_sql($con, $sql);
$doc_data = "";
if( $arr = db_fetch_array($ret) ){
	$doc_data = replace_json_txt($arr["txt"]);
	$doc_data = str_replace("\n", "\\n", $doc_data);
	$doc_data = str_replace("～", "〜", $doc_data);
	$doc_data = str_replace("―", "ー", $doc_data);
}

$json = new Services_JSON();
$decoded = $json->decode($doc_data);

if(is_null($decoded)){
	exit();
}

$fs_company = txt_default($decoded->fs_company, "12");
$fs_subject = txt_default($decoded->fs_subject, "12");
$fs_item1   = txt_default($decoded->fs_item1, "10");
$fs_item2   = txt_default($decoded->fs_item2, "10");
$fs_bikou   = txt_default($decoded->fs_bikou, "10");
$fs_bikou2  = txt_default($decoded->fs_bikou2, "10");

/*
$fs_bikou = "8";
$fs_item1 = "8";
$fs_item2 = "8";
$fs_bikou2 = "8";
*/

$fs_company_h = fs_h($fs_company);
$fs_subject_h = fs_h($fs_subject);
$fs_item1_h   = fs_h($fs_item1);
$fs_item2_h   = fs_h($fs_item2);
$fs_bikou_h   = fs_h($fs_bikou);
$fs_bikou2_h  = fs_h($fs_bikou2);

$title = "";
$title2 = "";
$target_date = "";
$target_bikou = "";
$file_name = $decoded->subject . ".pdf";

switch($mode){
	case "m":
		$title = "御見積書";
		$title2 = "お見積";
		$target_date = $decoded->m_date;
		$target_bikou = $decoded->m_bikou;
		$file_name = "[見積]" . $file_name;
		break;
	case "s":
		$title = "御請求書";
		$title2 = "ご請求";
		$target_date = $decoded->s_date;
		$target_bikou = $decoded->s_bikou;
		$file_name = "[請求]" . $file_name;
		break;
	case "n":
		$title = "納品書";
		$title2 = "納品";
		$target_date = $decoded->n_date;
		$target_bikou = $decoded->n_bikou;
		$file_name = "[納品]" . $file_name;
		break;
}
//$font_name = 'm-1vm-ipag-circle';
//$font_name = 'kozgopromedium';
//$font_name = 'fs-gothic';
//$font_name = 'dfgpaburi-w5d';
//$font_name = 'ipagp-mona';
//$font_name = 'ipagp';
//$font_name = 'kozminproregular';
$font_name = 'rcjfontpgothic';

// create new PDF document
$pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
//$pdf->setFontSubsetting(false);
$pdf->setPDFVersion("1.3");

//$font_name = $pdf->addTTFfont('./lib/tcpdf/fonts/ipagpmona.ttf', 'TrueTypeUnicode', '', 32);

// remove default header/footer
$pdf->setPrintHeader(false);
$pdf->setPrintFooter(false);

// set default monospaced font
//$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
$pdf->setLanguageArray($l);

$pdf->AddPage('P', 'A4');
//$pdf->AutoPageBreak = false;

//magor
/*
$mh = 20;
for ($i = 0; $i <= 209; $i++) {//174
	if($i % 10 == 0){
		$pdf->Line($i, $mh, $i, $mh +  8);
		$pdf->SetXY($i, $mh + 10);
		$pdf->Cell(10, 5, ''.$i, 1, 'L', 0, 0, '', '', true);
	}
	else if($i % 5 == 0) $pdf->Line($i, $mh, $i, $mh +  4);
	else $pdf->Line($i, $mh, $i, $mh +  2);
}
/**/

//sample
if($APP_SAMPLE == 1){
	$sample_txt = APP_TITLE . " サンプル版";
	$pdf->SetXY(0, 7);
	$pdf->SetFont($font_name, '', 8);
	$pdf->Cell(210, 10, $sample_txt, 0, 0, 'C', 0, '', 0, true);
}

//title
$pdf->SetXY(0, 17);
$pdf->SetFont($font_name, '', 20);
$pdf->Cell(210, 10, $title, 0, 0, 'C', 0, '', 0, true);

//No
$pdf->SetXY(159, 10);
$pdf->SetFont($font_name, '', 10);
$pdf->Cell(35, 4.5, 'No.' . $decoded->no, 'B', 0, 'L', 0, '', 0, true);

//YMD
$pdf->SetXY(159, 10+4.5+1);
$pdf->SetFont($font_name, '', 10);
$pdf->Cell(35, 4.5, '' . $target_date, 'B', 0, 'L', 0, '', 0, true);
//平成 24年 12月 31日

//company
$pdf->SetXY(18, 35);
//$pdf->SetFont($font_name, '', $fs_company);//8 10 12

$txt = $decoded->company;
search_str_fit_fs($txt, $pdf, 88, $font_name, 12);
$pdf->Cell(95, 6.5, '' . $txt, 'B', 0, 'L', 0, '', 0, true);


$pdf->SetXY(107, 35);
$pdf->Cell(10, 6.5, '様', 0, 0, 'L', 0, '', 0, true);

//社印
if($syain == "1"){
	$pdf->Image('./img/han.gif', ST_SYAIN_X, ST_SYAIN_Y, '', '', '', '', '', false, 300, '', false);
}

$bangou = $decoded->sp;

$company_name = ST_CNAME;

$address = ST_ZIP . PHP_EOL
		.ST_ADDRESS . PHP_EOL
		.'TEL ' . ST_TEL . PHP_EOL
		.'FAX ' . ST_FAX;

$tantou = ($decoded->tantou != "") ? "　担当：" . $decoded->tantou : "";
$address .= $tantou;

$pdf->SetXY(ST_SYAMEI_X, ST_SYAMEI_Y);
$pdf->SetFont($font_name, '', 10);
$pdf->MultiCell(100, 50, $bangou, 0, 'L', 0, 0, '', '', true);

$pdf->SetXY(ST_SYAMEI_X, ST_SYAMEI_Y + 4);
$pdf->SetFont($font_name, '', 11);
$pdf->Cell(95, 5, $company_name, 0, 0, 'L', 0, '', 0, true);

$pdf->SetXY(ST_SYAMEI_X, ST_SYAMEI_Y + 9);
$pdf->SetFont($font_name, '', 10);
$pdf->MultiCell(100, 50, $address, 0, 'L', 0, 0, '', '', true);


/*
for ($i = 1; $i <= 5; $i++) {
	$pdf->SetXY(134, 40 + ($i*8));
	
	$pdf->SetFont($font_name, '', 10); 
	switch($i){
		case 0 :$txt = '900'; break;
		case 1 :$txt = '9,000'; break;
		case 2 :$txt = '90,000'; break;
		case 3 :$txt = '900,000'; $pdf->SetFont($font_name, '', 10); break;
		case 4 :$txt = '9,000,000';$pdf->SetFont($font_name, '', 9); break;
		case 5 :$txt = '90,000,000'; $pdf->SetFont($font_name, '', 8); break;
	}
	
	$pdf->Cell(24, 8, "(非)" . $txt . "円", 1, 0, 'R', 0, 0, '', true);
}
*/


//subject
$pdf->SetXY(18, 60);
//$pdf->SetFont($font_name, '', $fs_subject);
$txt = '件名： ' . $decoded->subject;
search_str_fit_fs($txt, $pdf, 92, $font_name, 12);
$pdf->Cell(95, 6.5, $txt, 'B', 0, 'L', 0, '', 0, true);

//subject
$pdf->SetXY(18, 66);
$pdf->SetFont($font_name, '', 10);
$pdf->Cell(95, 6.5, '上記の件につきまして、下記の通り' . $title2 . 'いたします', 0, 0, 'L', 0, '', 0, true);

$pdf->SetXY(18, 80);
$pdf->SetFont($font_name, '', 12);
$pdf->Cell(95, 6.5, '税込合計金額', 'B', 0, 'L', 0, '', 0, true);

$pdf->SetXY(107, 80);
$pdf->Cell(10, 6.5, '円', 0, 0, 'L', 0, '', 0, true);

$txt = ($decoded->goukei_none == "1") ? "" : txt_en_no($decoded->sougoukei);

$pdf->SetFont($font_name, '', 16);
$pdf->SetXY(58, 79.5);
$pdf->Cell(35, 6.5, '' . $txt, 0, 0, 'R', 0, '', 0, true);


$sx = 18;
$sh = 90;
$pdf->SetXY($sx, $sh);


$c1 = 75;
$c2 = 17;
$c3 = 24;
$c4 = 24;
$c5 = 34;

/*
for ($i = 0; $i <= 18; $i++) {
	$pdf->Line($i, 98, $i, 98 +  2);
	if($i % 5 == 0) $pdf->Line($i, 98, $i, 98 +  4);
}

for ($i = 209 - 17; $i <= 209; $i++) {//174
	$pdf->Line($i, 98, $i, 98 +  2);
	if($i % 5 == 0) $pdf->Line($i, 98, $i, 98 +  4);
}/**/

//$pdf->Line($sx + $c_end , $sh, $sx + $c_end , $sh + $box_max);
$pdf->SetXY($sx, $sh + 0.1);
$pdf->SetFont($font_name, '', 10);
$pdf->Cell($c1, 5, '内容', 0, 'L', 0, 0, '', '', true);
$pdf->Cell($c2, 5, '数量', 0, 'L', 0, 0, '', '', true);
$pdf->Cell($c3, 5, '単価', 0, 'L', 0, 0, '', '', true);
$pdf->Cell($c4, 5, '金額', 0, 'L', 0, 0, '', '', true);
$pdf->Cell($c5, 5, '備考', 0, 'L', 0, 0, '', '', true);

$font_h = 4.6;

$sh += 6;
$c_end = $sx + $c1 + $c2 + $c3 + $c4 + $c5;

$h = 0;
$nh = $sh;
$add_h = 0;
$now_h = 0;

$txt_bikou_ = $target_bikou;
$h_bikou = txt_h($txt_bikou_, $pdf, $c1, $fs_bikou2_h) + $fs_bikou2_h;
$h_bikou_normal = $fs_bikou2_h * 6;

$max_h = 135;
if($h_bikou_normal < $h_bikou){
	$max_h = 135 + $h_bikou_normal - $h_bikou ;
	$h_bikou_normal = $h_bikou;
}
//$txt_bikou_ .= " $h_bikou $h_bikou_normal " . ($max_h);
//var_dump($decoded->item[0]);
$hikazei_display = 0;

for ($i = 0; $i <= 13; $i++) {

	$add_h =  $h;
	
	$txt = $decoded->item[$i]->item1;
	$h1 = txt_h($txt, $pdf, $c1, $fs_item1_h);

	$txt2 = $decoded->item[$i]->item2;
	$h2 = txt_h($txt2, $pdf, $c1, $fs_item2_h);
	
	$txt_bikou = $decoded->item[$i]->bikou;
	$h3 = txt_h($txt_bikou, $pdf, $c5, $fs_bikou_h);

	$h = ($h1 + $h2 < $h3) ? $h3 : ($h1 + $h2);

	if($h <= ($font_h) * 1){
		$h = ($font_h) * 2;
	}
	$now_h += $h;

	if(floatval($now_h) >= $max_h){
		break;
	}
	$nh += $add_h;
	
	//item1
	$pdf->SetXY($sx + 0.3, $nh + 0.1);
	$pdf->SetFont($font_name, '', $fs_item1);
	$pdf->MultiCell($c1, $h1, $txt, 0, 'L', 0, 0, '', '', true);//.$h

	//item2
	$pdf->SetXY($sx + 0.3, $nh + $h1 + 0);
	$pdf->SetFont($font_name, '', $fs_item2);
	$pdf->MultiCell($c1, $h2, $txt2, 0, 'L', 0, 0, '', '', true);
	
	//item waku
	$pdf->SetXY($sx, $nh);
	$pdf->SetFont($font_name, '', 10);//10-5,9-4,8-3
	$pdf->MultiCell($c1, $h, '', 0, 'L', 0, 0, '', '', true);//---waku---.$now_h

	//数量・単位
	$txt = '' . $decoded->item[$i]->num . $decoded->item[$i]->tani;
	$pdf->SetFont($font_name, '', str_fit_fs($txt, $pdf, $c2));
	$pdf->Cell($c2, $h, $txt, 0, 0, 'C', 0, 0, '', true);

	//単価
	$txt = txt_en($decoded->item[$i]->tanka);
	$pdf->SetFont($font_name, '', str_fit_fs($txt, $pdf, $c3));
	$pdf->Cell($c3, $h, $txt, 0, 0, 'R', 0, 0, '', true);

	//合計
	$txt = '';
	if($decoded->item[$i]->tanka != ""){
		$n = ($decoded->item[$i]->num == "") ? 1 : $decoded->item[$i]->num;
		$txt = txt_en($n * $decoded->item[$i]->tanka);
		$txt = ($decoded->item[$i]->kazei == "0") ? ("(非)" . $txt): $txt;
		
		if($hikazei_display == 0 && $decoded->item[$i]->kazei == "0"){
			$hikazei_display = 1;
		}
	}
	$pdf->SetFont($font_name, '', str_fit_fs($txt, $pdf, $c4));
	$pdf->Cell($c4, $h, $txt, 0, 0, 'R', 0, 0, '', true);

	//備考
	$pdf->SetFont($font_name, '', $fs_bikou);//10p 10 9p 11 8p 12/5
	$pdf->MultiCell($c5, $h, $txt_bikou, 0, 'L', 0, 0, '', '', true);
	
	$pdf->Line($sx, $nh + $h, $c_end, $nh + $h);
}
$sh -= 6;

$nh += $add_h;

$box_max = $nh + $h_bikou_normal;

//$pdf->SetLineStyle(array('width' => 0.4));

//横の線
$h = $h_bikou_normal / 3;
$pdf->Line($sx + $c1, $nh + $h, $c_end, $nh + $h);
$pdf->Line($sx + $c1, $nh + $h + $h, $c_end, $nh + $h + $h);

//$nh += 6;

//縦の線
//$pdf->Line($sx, $sh, $sx, $sh + $box_max);
$sxn = $sx + $c1;
$pdf->Line($sxn , $sh, $sxn , $box_max);
$sxn += $c2;
$pdf->Line($sxn , $sh, $sxn , $nh);
$sxn += $c3;
$pdf->Line($sxn , $sh, $sxn , $box_max);
$sxn += $c4;
$pdf->Line($sxn , $sh, $sxn , $box_max);
$sxn += $c5;
//$pdf->Line($sxn , $sh, $sxn , $sh + $box_max);



//sum bottom
//$pdf->Line($sx, $sh + $box_max - 30, $c_end, $sh + $box_max - 30);

$pdf->SetLineStyle(array('width' => 0.8));
$pdf->Line($sx, $sh, $c_end, $sh);
$pdf->Line($sx, $sh + 5.5, $c_end, $sh + 5.5);

$pdf->Line($sx, $sh, $sx, $box_max);//left
$pdf->Line($sxn , $sh, $sxn , $box_max);//right

//bottom
$pdf->Line($sx, $box_max, $c_end, $box_max);



//-------合計
$pdf->SetXY($sx, $nh);
$pdf->SetFont($font_name, '', $fs_bikou2);

$txt = '付記：' . PHP_EOL . $txt_bikou_;
$pdf->MultiCell($c1, $h_bikou, $txt, 0, 'L', 0, 0, '', '', true);

$txt = '合計';
$pdf->SetXY($sx + $c1 , $nh);
$pdf->SetFont($font_name, '', 10);
$pdf->Cell($c2 + $c3, $h, $txt, 0, 0, 'C', 0, 0, '', true);

$txt = ($decoded->goukei_none == "1") ? "" : txt_en($decoded->goukei);
$pdf->SetFont($font_name, '', str_fit_fs($txt, $pdf, $c4));
$pdf->Cell($c4, $h, $txt, 0, 0, 'R', 0, 0, '', true);

$m_date = $decoded->m_date;
$created = $decoded->created;
$ritu = zeiritu_per($m_date, $created, 0);

$txt = '消費税等（ ' . $ritu . '%）';
$pdf->SetXY($sx + $c1, $nh + ($h*1));
$pdf->SetFont($font_name, '', 10);
$pdf->Cell($c2 + $c3, $h, $txt, 0, 0, 'C', 0, 0, '', true);

$txt = ($decoded->goukei_none == "1") ? "" : txt_en($decoded->syouhizei);
$pdf->SetFont($font_name, '', str_fit_fs($txt, $pdf, $c4));
$pdf->Cell($c4, $h, $txt, 0, 0, 'R', 0, 0, '', true);

$txt = '税込合計金額';
$pdf->SetXY($sx + $c1, $nh + ($h*2));
$pdf->SetFont($font_name, '', 10);
$pdf->Cell($c2 + $c3, $h, $txt, 0, 0, 'C', 0, 0, '', true);

$txt = ($decoded->goukei_none == "1") ? "" : txt_en($decoded->sougoukei);
$pdf->SetFont($font_name, '', str_fit_fs($txt, $pdf, $c4));
$pdf->Cell($c4, $h, $txt, 0, 0, 'R', 0, 0, '', true);

$bottom_y = $nh + $h_bikou_normal + 2;

//有効期限
if($mode == "m" && $decoded->yuukoukigen != ""){
	$pdf->SetXY(0, $bottom_y);
	$pdf->SetFont($font_name, '', 10);
	$pdf->MultiCell(190, 10, '有効期限：'.$decoded->yuukoukigen, 0, 'R', 0, 0, '', '', true);
}

//非課税注釈
if($hikazei_display == 1){
	$pdf->SetXY(135, 86);
	$pdf->SetFont($font_name, '', 7);
	$pdf->MultiCell(50, 10, '※(非)は非課税です', 0, 'L', 0, 0, '', '', true);
}

//振込先
if($mode == "s"){
	$pdf->SetXY(18, $bottom_y);
	$pdf->SetFont($font_name, '', 10);
	$pdf->MultiCell(20, 10, '御振込先：', 0, 'R', 0, 0, '', '', true);

	$txt= ST_FURIKOMI1 . PHP_EOL .ST_FURIKOMI2;

	$pdf->SetXY(40, $bottom_y);
	$pdf->MultiCell(100, 10, $txt, 0, 'L', 0, 0, '', '', true);

	$bottom_y += 10;
	$pdf->SetXY(18, $bottom_y);
	$pdf->MultiCell(20, 5, '名義：', 0, 'R', 0, 0, '', '', true);

	$pdf->SetXY(40, $bottom_y);
	$pdf->MultiCell(100, 5, ST_FURIKOMI_MEIGI, 0, 'L', 0, 0, '', '', true);
}

if($dl1 == "1"){
	$pdf->Output($file_name, 'D');
}else{
	$pdf->Output($file_name, 'I');
}
